groups:
  - name: general-missing-series-alerts.yml
    rules:
      # Ops Rate
      - alert: gitlab_component_opsrate_missing_series
        expr: |
          (gitlab_component_ops:rate offset 1d)
          unless
          gitlab_component_ops:rate
        for: 1h
        labels:
          rules_domain: general
          severity: s4
        annotations:
          title: "Operation rate data for the `{{ $labels.component }}` component of the `{{ $labels.type }}` service (`{{ $labels.stage }}` stage) is missing"
          description: >
            The data used to generate the `gitlab_component_ops:rate` metrics are missing for the
            `{{ $labels.component }}` component of the `{{ $labels.type }}` service. This
            might indicate that our observability has been affected.
          grafana_dashboard_id: "Z4W91Zbmk/general-triage-missing-component-series-data"
          grafana_panel_id: "42"
          grafana_variables: "environment,type,component,stage"
          grafana_min_zoom_hours: "24"

      # Apdex
      - alert: gitlab_component_apdex_missing_series
        expr: |
          (gitlab_component_apdex:ratio offset 1d)
          unless
          gitlab_component_apdex:ratio
        for: 1h
        labels:
          rules_domain: general
          severity: s4
        annotations:
          title: "Apdex for the `{{ $labels.component }}` component of the `{{ $labels.type }}` service (`{{ $labels.stage }}` stage) is missing"
          description: >
            The data used to generate the `gitlab_component_apdex:ratio` metrics are missing for the
            `{{ $labels.component }}` component of the `{{ $labels.type }}` service. This
            might indicate that our observability has been affected.
          grafana_dashboard_id: "Z4W91Zbmk/general-triage-missing-component-series-data"
          grafana_panel_id: "19"
          grafana_variables: "environment,type,component,stage"
          grafana_min_zoom_hours: "24"

      # Error Rate
      # For error rate, ignore the `cny` stage, as without much traffic,
      # the likelihood of errors will be reduced, leading to
      # `gitlab_component_error_missing_series` alerts
      - alert: gitlab_component_error_missing_series
        expr: |
          (gitlab_component_errors:rate{stage!="cny"} offset 1d)
          unless
          gitlab_component_errors:rate{stage!="cny"}
        for: 1h
        labels:
          rules_domain: general
          severity: s4
        annotations:
          title: "Error rate data for the `{{ $labels.component }}` component of the `{{ $labels.type }}` service (`{{ $labels.stage }}` stage) is missing"
          description: >
            The data used to generate the `gitlab_component_errors:rate` metrics are missing for the
            `{{ $labels.component }}` component of the `{{ $labels.type }}` service. This
            might indicate that our observability has been affected.
          grafana_dashboard_id: "Z4W91Zbmk/general-triage-missing-component-series-data"
          grafana_panel_id: "27"
          grafana_variables: "environment,type,component,stage"
          grafana_min_zoom_hours: "24"
